local speedconversion = 48550
local skinsInUse = {}

addHook("NetVars", function(net)
	speedconversion = net($)
	skinsInUse = net($)
end)

local cv_dynaskins_enabled = CV_RegisterVar{
	name = "dynaskins_enabled",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = {off = 0, on = 1}
}

local cv_dynaskins_message = CV_RegisterVar{
	name = "dynaskins_message",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = {off = 0, on = 1}
}

local cv_dynaskins_force = CV_RegisterVar{
	name = "dynaskins_force",
	defaultvalue = "off",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = {off = 0, unique = 1, rainbow = 2, place = 3, item = 4, speedBR = 5, speedBW = 6, speedPB = 7, speedG = 8, speedR = 9, speedB = 10, speedPP = 11, speedO = 12, state = 13},
	func = function(cv)
		for p in players.iterate
			p.initSkin = true
		end
	end 
}

local cv_dynaskins_default = CV_RegisterVar{
	name = "dynaskins_default",
	defaultvalue = "state",
	flags = CV_NETVAR,
	PossibleValue = {off = 0, rainbow = 2, place = 3, item = 4, speedBR = 5, speedBW = 6, speedPB = 7, speedG = 8, speedR = 9, speedB = 10, speedPP = 11, speedO = 12, state = 13}
}

local cv_dynaskins_cps = CV_RegisterVar{
	name = "dynaskins_cps",
	defaultvalue = 3,
	flags = CV_NETVAR,
	PossbibleValue = {MIN = 1, MAX = 5}
}

local roygbiv = {}
roygbiv[24] = 28	--R
roygbiv[28] = 34
roygbiv[34] = 38	--O
roygbiv[38] = 47
roygbiv[47] = 53	--Y
roygbiv[53] = 61
roygbiv[61] = 70	--G
roygbiv[70] = 73
roygbiv[73] = 85	--B
roygbiv[85] = 86
roygbiv[86] = 90	--I
roygbiv[90] = 91
roygbiv[91] = 99	--V
roygbiv[99] = 24
					--R
					
local place = {}
place[1] = 42
place[2] = 2
place[3] = 44
place[4] = 83
place[5] = 21
place[6] = 1
place[7] = 47
place[8] = 63
place[9] = 17
place[10] = 93
place[11] = 40
place[12] = 78
place[13] = 33
place[14] = 60
place[15] = 8
place[16] = 5

local speedBR = {}
speedBR[0] = 86
speedBR[1] = 90
speedBR[2] = 89
speedBR[3] = 88
speedBR[4] = 21
speedBR[5] = 22

local speedBW = {}
speedBW[0] = 5
speedBW[1] = 4
speedBW[2] = 3
speedBW[3] = 2
speedBW[4] = 1

local speedPB = {}
speedPB[0] = 98
speedPB[1] = 97
speedPB[2] = 96
speedPB[3] = 90
speedPB[4] = 74
speedPB[5] = 72

local speedPP = {}
speedPP[0] = 98
speedPP[1] = 97
speedPP[2] = 96
speedPP[3] = 88
speedPP[4] = 92
speedPP[5] = 100

local speedR = {}
speedR[0] = 26
speedR[1] = 25
speedR[2] = 24
speedR[3] = 23
speedR[4] = 22
speedR[5] = 16

local speedG = {}
speedG[0] = 64
speedG[1] = 62
speedG[2] = 61
speedG[3] = 63
speedG[4] = 60
speedG[5] = 53

local speedB = {}
speedB[0] = 82
speedB[1] = 86
speedB[2] = 85
speedB[3] = 84
speedB[4] = 73
speedB[5] = 72

local speedO = {}
speedO[0] = 36
speedO[1] = 35
speedO[2] = 28
speedO[3] = 34
speedO[4] = 38
speedO[5] = 33

local item = {}
item[KITEM_SNEAKER] = 24
item[KITEM_ROCKETSNEAKER] = 24
item[KITEM_INVINCIBILITY] = 87
item[KITEM_BANANA] = 47
item[KITEM_EGGMAN] = 58
item[KITEM_ORBINAUT] = 2
item[KITEM_JAWZ] = 73
item[KITEM_MINE] = 75
item[KITEM_BALLHOG] = 94
item[KITEM_SPB] = 5
item[KITEM_GROW] = 85
item[KITEM_SHRINK] = 28
item[KITEM_THUNDERSHIELD] = 42
item[KITEM_HYUDORO] = 1
item[KITEM_POGOSPRING] = 30
item[KITEM_KITCHENSINK] = 95

local state = {}
--Other
state[0] = 5	--Hurt
state[1] = 42	--High speed
state[2] = 1	--Airborne
state[3] = 25	--Offroad
--Blues
state[10] = 82	--Hurt
state[11] = 72	--High speed
state[12] = 84	--Airborne
state[13] = 86	--Offroad
--Purples/Pinks
state[20] = 98	--Hurt
state[21] = 100	--High speed
state[22] = 92	--Airborne
state[23] = 91	--Offroad
--Reds
state[30] = 26	--Hurt
state[31] = 22	--High speed
state[32] = 16	--Airborne
state[33] = 25	--Offroad
--Greens
state[40] = 64	--Hurt
state[41] = 53	--High speed
state[42] = 56	--Airborne
state[43] = 62	--Offroad
--Oranges
state[50] = 37	--Hurt
state[51] = 33	--High speed
state[52] = 38	--Airborne
state[53] = 36	--Offroad
--Grayscale
state[60] = 5	--Hurt
state[61] = 1	--High speed
state[62] = 10	--Airborne
state[63] = 4	--Offroad


local function pickPalette(p)
	if (p.originalColor > 67 and p.originalColor < 79) or (p.originalColor > 81 and p.originalColor < 87) --Blues
		p.palette = 1
	elseif (p.originalColor > 16 and p.originalColor < 20) or p.originalColor == 27 or p.originalColor == 39 or p.originalColor > 86 --Purples/Pinks
		p.palette = 2
	elseif p.originalColor == 16 or (p.originalColor > 20 and p.originalColor < 27) --Reds
		p.palette = 3
	elseif p.originalColor > 52 and p.originalColor < 68 --Greens
		p.palette = 4
	elseif p.originalColor == 20 or (p.originalColor > 27 and p.originalColor < 39) --Oranges
		p.palette = 5
	elseif p.originalColor > 0 and p.originalColor < 11 --Grayscale
		p.palette = 6
	else	--Other (Ugly Colors)
		p.palette = 0
	end
end

local function dynaskinsChange(p, arg)
	if arg == nil then
		CONS_Printf(p, "Dynaskins options:")
		CONS_Printf(p, "dynaskins rainbow   (Cycle through roygbiv)")
		CONS_Printf(p, "dynaskins place     (Your color changes based on your placement in the race)")
		CONS_Printf(p, "dynaskins item      (Your color changes based on the item you're holding)")
		CONS_Printf(p, "dynaskins state     (Your color changes under certain conditions)")		
		CONS_Printf(p, "dynaskins speedBR   (Blue -> Red, your color changes based on your speed)")
		CONS_Printf(p, "dynaskins speedBW   (Black -> White)")
		CONS_Printf(p, "dynaskins speedPB   (Purple -> Blue)")
		CONS_Printf(p, "dynaskins speedPP   (Purple -> Pink)")
		CONS_Printf(p, "dynaskins speedR    (Dark Red -> Light Red)")
		CONS_Printf(p, "dynaskins speedG    (Dark Green -> Light Green)")
		CONS_Printf(p, "dynaskins speedB    (Dark Blue -> Light Blue)")
		CONS_Printf(p, "dynaskins speedO    (Dark Orange -> Light Orange)")
		CONS_Printf(p, "dynaskins off       (Disable any active dynaskin)")
		return
	elseif arg:lower() == "off" then
		arg = 0
	elseif arg:lower() == "rainbow" then
		arg = 2
	elseif arg:lower() == "place" then
		arg = 3
	elseif arg:lower() == "item" then
		arg = 4
	elseif arg:lower() == "speedbr" then
		arg = 5
	elseif arg:lower() == "speedbw" then
		arg = 6
	elseif arg:lower() == "speedpb" then
		arg = 7
	elseif arg:lower() =="speedg" then
		arg = 8
	elseif arg:lower() =="speedr" then
		arg = 9
	elseif arg:lower() =="speedb" then
		arg = 10
	elseif arg:lower() =="speedpp" then
		arg = 11
	elseif arg:lower() =="speedo" then
		arg = 12
	elseif arg:lower() =="state" then
		arg = 13
	end
	arg = tonumber(arg)
	
	if arg == 1 or arg == 2 or arg == 3 or arg == 4 or arg == 5 or arg == 6 or arg == 7 or arg == 8 or arg == 9 or arg == 10 or arg == 11 or arg == 12 or arg == 13 then
		if cv_dynaskins_force.value == 1 and not (p.dynaskins == 0 or p.dynaskins == 3 or p.dynaskins == 4 or p.dynaskins == 13)
			local skinWant = tostring(p.mo.skin) + tostring(arg)
			local dup = false
			for key, combo in pairs(skinsInUse)
				if skinWant == combo
					dup = true
					break
				end
			end
			if dup == true
				CONS_Printf(p, "This combination of character and dynaskin are already in use. Please select another.")
				return
			else
				skinsInUse[skinWant] = skinWant
			end
		end
		
		p.initSkin = true
		p.dynaskin = arg
		p.shutup = true
		p.blinking = false
		
	elseif arg == 0 and p.originalColor ~= nil and p.originalColor ~= 0
		p.skincolor = p.originalColor
		p.mo.color = p.originalColor
		p.originalColor = 0
		p.dynaskin = 0
		p.blinking = true
	else
		CONS_Printf(p, "Invalid option")
	end 
end
COM_AddCommand("dynaskins", dynaskinsChange, 0)

local function skinInit(p)
	local doSkin = p.dynaskin
	if cv_dynaskins_force.value > 1
		doSkin = cv_dynaskins_force.value
	end
	
	if doSkin == 2
		--print("Init Rainbow")
		local startcolor = 24
		local rand = P_RandomFixed() % 14
		for i=0,rand
			startcolor = roygbiv[startcolor]
		end
		p.skincolor = startcolor
		p.mo.color = startcolor
	elseif doSkin == 3
		--print("Init Place")
		p.skincolor = place[p.kartstuff[k_position]]
		p.mo.color = p.skincolor
	elseif doSkin == 4
		--print("Init Item")
		if p.originalColor ~= nil and p.originalColor > 0
			--print("Init Item color")
			p.skincolor = p.originalColor
			p.mo.color = p.originalColor
		else
			p.originalColor = p.skincolor
		end
	elseif doSkin == 5
		p.skincolor = speedBR[0]
		p.mo.color = speedBR[0]
	elseif doSkin == 6
		p.skincolor = speedBW[0]
		p.mo.color = speedBW[0]
	elseif doSkin == 7
		p.skincolor = speedPB[0]
		p.mo.color = speedPB[0]
	elseif doSkin == 8
		p.skincolor = speedG[0]
		p.mo.color = speedG[0]
	elseif doSkin == 9
		p.skincolor = speedR[0]
		p.mo.color = speedR[0]
	elseif doSkin == 10
		p.skincolor = speedB[0]
		p.mo.color = speedB[0]
	elseif doSkin == 11
		p.skincolor = speedPP[0]
		p.mo.color = speedPP[0]
	elseif doSkin == 12
		p.skincolor = speedO[0]
		p.mo.color = speedO[0]
	elseif doSkin == 13
		--print("Init state")
		if p.originalColor ~= nil and p.originalColor > 0
			p.skincolor = p.originalColor
			p.mo.color = p.originalColor
		else
			p.originalColor = p.skincolor
		end		
		pickPalette(p)
	elseif doSkin == 0
		if p.originalColor ~= nil and p.originalColor > 0
			--print("Init Item color")
			p.skincolor = p.originalColor
			p.mo.color = p.originalColor
		else
			p.originalColor = p.skincolor
		end
	elseif doSkin ~= 0
		--print("No dynaskin initialized")
		p.dynaskin = 0
	end
	p.expected = p.skincolor
	p.lastChange = leveltime
end

local function dynaskinsShutup(p, arg)
	p.shutup = true
end
COM_AddCommand("dynaskins_shutup", dynaskinsShutup, 0)

local function doskinThink(p, skin)
	if leveltime >= p.lastChange + TICRATE / cv_dynaskins_cps.value
		if skin == 2
			if roygbiv[p.skincolor] ~= nil
				p.skincolor = roygbiv[p.skincolor]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end	
		elseif skin == 3
			if place[p.kartstuff[k_position]] ~= nil and p.skincolor ~= place[p.kartstuff[k_position]] and not p.exiting
				--print("Running Place")
				p.skincolor = place[p.kartstuff[k_position]]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
		elseif skin == 4
			if p.kartstuff[k_itemtype] ~= nil and item[p.kartstuff[k_itemtype]] ~= nil 
				if p.skincolor ~= item[p.kartstuff[k_itemtype]]
					--print("Running Item")
					p.skincolor = item[p.kartstuff[k_itemtype]]
					p.mo.color = p.skincolor
					p.lastChange = leveltime
				end
			elseif p.skincolor ~= p.originalColor
				p.skincolor = p.originalColor
				p.mo.color = p.skincolor
				p.lastChange = leveltime						
			end
		elseif skin == 5 
			local speedtier = p.speed / speedconversion / 15
			if speedBR[speedtier] ~= nil and p.skincolor ~= speedBR[speedtier] and not p.exiting
				--print("Running speedBR")
				p.skincolor = speedBR[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
			
		elseif skin == 6
			local speedtier = min(p.speed / speedconversion / 19, 4)
			if speedBW[speedtier] ~= nil and p.skincolor ~= speedBW[speedtier] and not p.exiting
				--print("Running speedBW")
				p.skincolor = speedBW[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
			
		elseif skin == 7
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedPB[speedtier] ~= nil and p.skincolor ~= speedPB[speedtier] and not p.exiting
				--print("Running speedPB")
				p.skincolor = speedPB[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
			
		elseif skin == 8
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedG[speedtier] ~= nil and p.skincolor ~= speedG[speedtier] and not p.exiting
				--print("Running speedG")
				p.skincolor = speedG[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
			
		elseif skin == 9
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedR[speedtier] ~= nil and p.skincolor ~= speedR[speedtier] and not p.exiting
				--print("Running speedR")
				p.skincolor = speedR[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end		
			
		elseif skin == 10
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedB[speedtier] ~= nil and p.skincolor ~= speedB[speedtier] and not p.exiting
				--print("Running speedB")
				p.skincolor = speedB[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end		
			
		elseif skin == 11
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedPP[speedtier] ~= nil and p.skincolor ~= speedPP[speedtier] and not p.exiting
				--print("Running speedPP")
				p.skincolor = speedPP[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end	
			
		elseif skin == 12
			local speedtier = min(p.speed / speedconversion / 15, 5)
			if speedO[speedtier] ~= nil and p.skincolor ~= speedO[speedtier] and not p.exiting
				--print("Running speedO")
				p.skincolor = speedO[speedtier]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end	
		elseif skin == 13
			--print("Running state")
			if p.kartstuff[k_spinouttimer] > 0 --hurt
				--print("Running hurt")
				p.skincolor = state[10*p.palette]
				p.mo.color = p.skincolor
				p.lastChange = leveltime					
			elseif (p.speed / speedconversion) > 75
				--print("Running hispeed")
				p.skincolor = state[10*p.palette + 1]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			elseif not P_IsObjectOnGround(p.mo)
				--print("Running airtime")
				p.skincolor = state[10*p.palette + 2]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			elseif p.kartstuff[k_offroad] > 0
				--print("Running offroad")
				p.skincolor = state[10*p.palette + 3]
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			elseif p.skincolor ~= p.originalColor
				p.skincolor = p.originalColor
				p.mo.color = p.skincolor
				p.lastChange = leveltime
			end
		elseif p.dynaskin ~= 0
			print("Error Occured while running dynaskin")
			p.dynaskin = 0
		end
	end
end

local function dynaskinsThink()
	if not cv_dynaskins_enabled.value then return end
	for p in players.iterate
		if p.dynaskin == nil
			p.dynaskin = cv_dynaskins_default.value
			p.expected = 0
			p.shutup = false
			p.lastChange = 0
		end
		if not (p and p.valid) then continue end
		if not p.cmd.buttons	--they're in the menu
			if p.expected ~= p.skincolor and not p.initSkin
				p.menu = true
				p.originalColor = p.skincolor
				--p.skincolor = p.expected
			end
		else
			if p.menu == true
				p.menu = false
				p.initSkin = true
			end
		end
		
		if not (p.mo and p.mo.valid) then continue end
		if p.initSkin
			if p.originalColor == nil or p.originalColor == 0
				p.originalColor = p.skincolor
			end
			skinInit(p)
			p.initSkin = false
		end
	end
	if leveltime == 1 then
		speedconversion = 100* mapheaderinfo[gamemap].mobj_scale / FRACUNIT * 48550 / 100
		skinsInUse = {}
		for p in players.iterate
			if not (p and p.valid and p.mo and p.mo.valid) then continue end
			skinInit(p)
			if cv_dynaskins_force.value == 1 and not (p.dynaskins == 0 or p.dynaskins == 3 or p.dynaskins == 4 or p.dynaskins == 13)
				local skinWant = tostring(p.mo.skin) + tostring(p.dynaskin)
				local dup = false
				for key, combo in pairs(skinsInUse)
					if skinWant == combo
						dup = true
						break
					end
				end
				if dup == true
					CONS_Printf(p, "This combination of character and dynaskin are already in use. Please select another.")
					dynaskinsChange(p, "off")
				else
					skinsInUse[skinWant] = skinWant
				end
			end
			if cv_dynaskins_message.value == 1 and not p.shutup and not (p.dynaskin > 1) and not (cv_dynaskins_force.value > 1)
				chatprintf(p, 'This server has dynamic skins!', true)
				chatprintf(p, 'Type "dynaskins" in the console to view available skins.', true)
				chatprintf(p, 'Type "dynaskins_shutup" in the console to mute this message.', true)
			end
		end
	end
	
	if cv_dynaskins_force.value > 1
		for p in players.iterate
			if not (p and p.valid and p.mo and p.mo.valid) then continue end
			doskinThink(p, cv_dynaskins_force.value)
			p.expected = p.skincolor
		end
	else
		--regular independent skins
		for p in players.iterate
			if not (p and p.valid and p.mo and p.mo.valid) then continue end
			doskinThink(p, p.dynaskin)
			p.expected = p.skincolor				
		end
	end	
end

addHook("ThinkFrame", dynaskinsThink)